/*
 * fepctrl.h 1.0 1990/06/06	Public Domain.
 *
 * General purpose Japanese FEP control routines for MS-DOS.
 * Written by Junn Ohta <ohta@src.ricoh.co.jp>
 */

/*
 * Japanese FEP type (returned by fep_init())
 */
#define	FEP_NONE     0
#define	FEP_PC98     1	/* Unknown FEP with FP$DUMMY (PC-9801 only) */
#define	FEP_MSKANJI  2	/* MS-KANJI Application Interface */
#define	FEP_VJE      3	/* VACS Japanese Entry System Alpha/Sigma/Beta */
#define	FEP_ATOK6    4	/* JUSTSYSTEM's Automatic Transfer of Kana-Kanji 6 */
#define	FEP_ATOK7    5	/* JUSTSYSTEM's Automatic Transfer of Kana-Kanji 7 */
#define	FEP_MTTK86   6	/* K3's Matsutake (pinetree mushroom) 86 */
#define	FEP_MTTK2    7	/* K3's Matsutake (pinetree mushroom) Ver.2 */
#define	FEP_KATANA   8	/* Something Good's Katana/ACE */
#define	FEP_FIXER    9	/* Software Society's FIXER3/FIXER4 */
#define	FEP_EGB2    10	/* ERGOSOFT's EGBridge Ver.2 */
#define	FEP_EGB3    11	/* ERGOSOFT's EGBridge Ver.3 */
#define	FEP_WXP     12	/* A.I.Soft's WXP (and WX, WXS ?) */
#define	FEP_MGR2    13	/* REED REX's MGR2 */
#define	FEP_NECAIK  14	/* NEC's AI Kana-Kanji Henkan */
#define	FEP_DFJ     15	/* Digital Farm's DFJ Ver.1 */

#define	NFEPS       16	/* Number of FEPs defined */

int	fep_init();
void	fep_term();
void	fep_on(), fep_off();
void	fep_force_on(), fep_force_off();
