/* $Header: /nw/tony/src/stevie/src/RCS/main.c,v 1.12 89/08/02 19:53:27 tony Exp $
 *
 * The main routine and routines to deal with the input buffer.
 */

#include "stevie.h"

int Rows;		/* Number of Rows and Columns */
int Columns;		/* in the current window. */

uchar **Realscreen = NULL;	/* What's currently on the screen, an array */
				/* of size Rows*2 of pointer to the line. */
uchar **Nextscreen = NULL;	/* What's to be put on the screen. */

uchar *Filename = NULL;	/* Current file name */

LPTR *Filemem;		/* Pointer to the first line of the file */

LPTR *Filetop;		/* Line 'above' the start of the file */

LPTR *Fileend;		/* Pointer to the end of the file in Filemem. */
			/* (It points to the byte AFTER the last byte.) */

LPTR *Topchar;		/* Pointer to the byte in Filemem which is */
			/* in the upper left corner of the screen. */

LPTR *Botchar;		/* Pointer to the byte in Filemem which is */
			/* just off the bottom of the screen. */

LPTR *Curschar;		/* Pointer to byte in Filemem at which the */
			/* cursor is currently placed. */

int Cursrow, Curscol;	/* Current position of cursor */

int Cursvcol;		/* Current virtual column, the column number of */
			/* the file's actual line, as opposed to the */
			/* column number we're at on the screen.  This */
			/* makes a difference on lines that span more */
			/* than one screen line. */

int Curswant = 0;	/* The column we'd like to be at. This is used */
			/* try to stay in the same column through up/down */
			/* cursor motions. */

bool_t set_want_col;	/* If set, then update Curswant the next time */
			/* through cursupdate() to the current virtual */
			/* column. */

int State = NORMAL;	/* This is the current state of the command */
			/* interpreter. */

int Prenum = 0;		/* The (optional) number before a command. */

LPTR *Insstart;		/* This is where the latest insert/append */
			/* mode started. */

bool_t Changed = 0;	/* Set to 1 if something in the file has been */
			/* changed and not written out. */

uchar Redobuff[IBSIZE];	/* Each command should stuff characters into this */
			/* buffer that will re-execute itself. */

uchar Insbuff[IBSIZE];	/* Each insertion gets stuffed into this buffer. */

int Ninsert = 0;	/* Number of characters in the current insertion. */
uchar *Insptr = NULL;

bool_t	got_int=FALSE;	/* set to TRUE when an interrupt occurs (if possible) */

bool_t	interactive = FALSE;	/* set TRUE when main() is ready to roll */

MAP	Maptab[MAXMAP];	/* table for mappings */
int	nmap = 0;	/* number of maps (initially 0) */
bool_t	can_ab = TRUE;	/* can start abbreviations? */

char **files;		/* list of input files */
int  numfiles;		/* number of input files */
int  curfile;		/* number of the current file */

#ifdef KANJI
#ifdef SJIS
/*
 * first byte of Shift-JIS kanji
 */
uchar	kanji1[] = {
/* 0x00 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x10 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x20 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x30 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x40 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x50 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x60 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x70 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x80 */	0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0x90 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xA0 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0xB0 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0xC0 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0xD0 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0xE0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xF0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0
};
#else /*EUC or JIS*/
/*
 * first byte of EUC kanji
 */
uchar	kanji1[] = {
/* 0x00 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x10 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x20 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x30 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x40 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x50 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x60 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x70 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x80 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0x90 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 0xA0 */	0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xB0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xC0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xD0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xE0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/* 0xF0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0
};
#endif
#endif

static void
usage()
{
	fprintf(stderr, "usage: stevie [-R] [file ...]\n");
	fprintf(stderr, "       stevie -t tag\n");
	fprintf(stderr, "       stevie +[num] file\n");
	fprintf(stderr, "       stevie +/pat  file\n");
	fprintf(stderr, "       stevie +?pat  file\n");
	exit(1);
}

main(argc,argv)
int	argc;
char	**argv;
{
	uchar	*initstr, *getenv();	/* init string from the environment */
	uchar	*tag = NULL;		/* tag from command line */
	uchar	*pat = NULL;		/* pattern from command line */
	int	line = -1;		/* line number from command line */
	uchar	*p, buf[MAXCLIN];
	bool_t	view = FALSE;		/* invoked as "*view" */
	int	n;

	/*
	 * Check if stevie is invoked as "view", "steview", "stevie -R"
	 */
	if ((n = strlen(*argv)) >= 4) {
		p = (uchar *)*argv + n - 4;
		if (!strcmp(p, "view"))
			view = TRUE;
	}
	argc--, argv++;
	if (argc > 0 && !strcmp(*argv, "-R")) {
		view = TRUE;
		argc--, argv++;
	}

	/*
	 * Process the command line arguments.
	 */
	if (argc > 0) {
		switch (**argv) {
		
		case '-':			/* -t tag */
			if (*++*argv != 't')
				usage();
			if (argc != 2 || argv[1] == NULL)
				usage();
			Filename = NULL;
			tag = (uchar *)argv[1];
			numfiles = 1;
			break;

		case '+':			/* +n or +/pat or +?pat */
			if (*++*argv == '/' || **argv == '?') {
				if (argc != 2 || argv[1] == NULL)
					usage();
				Filename = strsave(argv[1]);
				pat = (uchar *)*argv;
				numfiles = 1;
			} else if (isdigit(**argv) || *argv == NUL) {
				if (argc != 2 || argv[1] == NULL)
					usage();
				Filename = strsave(argv[1]);
				numfiles = 1;
				line = (isdigit(**argv))? atoi(*argv): 0; } else
				usage();

			break;

		default:			/* must be a file name */
			Filename = strsave(*argv);
			numfiles = argc;
			files = (char **)alloc(numfiles * sizeof(char *));
			if (files == NULL)
				exit(1);
			for (n = 0; n < numfiles; n++) {
				files[n] = (char *)strsave(argv[n]);
				if (files[n] == NULL)
					exit(1);
			}
			break;
		}
	} else {
		Filename = NULL;
		numfiles = 1;
	}
	curfile = 0;

 	if (numfiles > 1)
 		fprintf(stderr, "%d files to edit\n", numfiles);
 
	windinit();

	/*
	 * Allocate LPTR structures for all the various position pointers
	 */
 	if ((Filemem = (LPTR *) malloc(sizeof(LPTR))) == NULL ||
 	    (Filetop = (LPTR *) malloc(sizeof(LPTR))) == NULL ||
 	    (Fileend = (LPTR *) malloc(sizeof(LPTR))) == NULL ||
 	    (Topchar = (LPTR *) malloc(sizeof(LPTR))) == NULL ||
 	    (Botchar = (LPTR *) malloc(sizeof(LPTR))) == NULL ||
 	    (Curschar = (LPTR *) malloc(sizeof(LPTR))) == NULL ||
 	    (Insstart = (LPTR *) malloc(sizeof(LPTR))) == NULL ) {
		fprintf(stderr, "Can't allocate data structures\n");
		windexit(0);
	}

	screenalloc();
	filealloc();		/* Initialize Filemem, Filetop, and Fileend */

	screenclear();

	if ((initstr = getenv("EXINIT")) != NULL)
		docmdln(initstr);
	else if ((p = getenv("HOME")) != NULL)
		doinitfile(mkpath(p, Initfile));

	doinitfile(Initfile);

	if ((p = getenv("LINES")) != NULL) {
		sprintf(buf, "set lines=%s", p);
		docmdln(buf);
	}

	if (view)
		P(P_RO) = TRUE;

	if (Filename != NULL) {
		if (readfile(Filename, Filemem, FALSE))
			filemess("[New File]");
	} else if (tag == NULL)
		/* msg("Empty Buffer") */;

	setpcmark();

	if (tag) {
		stuffin(":ta ");
		stuffin(tag);
		stuffin("\n");

	} else if (pat) {
		stuffin(pat);
		stuffin("\n");

	} else if (line >= 0) {
		if (line > 0)
			stuffnum(line);
		stuffin("G");
	}

	interactive = TRUE;

	edit();

	windexit(0);

	return 1;		/* shouldn't be reached */
}

static uchar getcbuff[IBSIZE];
static uchar *getcnext = NULL;
static uchar mapcbuff[MBSIZE];
static uchar *mapcnext = NULL;

void
stuffin(s)
uchar	*s;
{
	if (s == NULL) {		/* clear the stuff buffer */
		getcnext = NULL;
		return;
	}
	if (getcnext == NULL) {
		strcpy(getcbuff,s);
		getcnext = getcbuff;
	} else if (getcnext + strlen(s) < getcbuff + IBSIZE - 1)
		strcat(getcbuff,s);
}

void
stuffnum(n)
int	n;
{
	uchar	buf[32];

	sprintf(buf, "%d", n);
	stuffin(buf);
}

static void
mapback(s)
uchar	*s;
{
	uchar	buf[MBSIZE];

	if (mapcnext == NULL) {
		strcpy(mapcbuff, s);
		mapcnext = mapcbuff;
	} else {
		if (strlen(mapcnext) + strlen(s) >= MBSIZE) {
			emsg("Infinite macro loop");
			mapcnext = NULL;
			return;
		}
		strcpy(buf, mapcnext);
		strcpy(mapcbuff, s);
		strcat(mapcbuff, buf);
		mapcnext = mapcbuff;
	}
}

int
map(c)
int	c;
{
	int	i, mlen;
	uchar	*p, *q;
	MAP	*m, *mpos;
	bool_t	partof;
	static bool_t	lnext = FALSE;		/* last char was ^V */
	static bool_t	abbrev = FALSE;		/* now processing ab */
	static bool_t	abdone = FALSE;		/* just matched ab */
	static MAP	*msave;
	static uchar	mbuf[MAXCLIN];

	if (c == -1) {
		return c;
	}
	if (lnext) {
		lnext = FALSE;
		return c;
	}
	if (c == Ctrl('V') && *mbuf == NUL) {
		lnext = TRUE;
		return c;
	}
	if (c == BS && abbrev) {
		for (p = mbuf; *p; p++) {
#ifdef KANJI
			if (isKanji(*p) && p[2] == NUL || p[1] == NUL)
				break;
#else
			if (p[1] == NUL)
				break;
#endif
		}
		*p = NUL;
		abdone = FALSE;
		if (*mbuf == NUL)
			abbrev = FALSE;
		return c;
	}
	if (abdone) {
		abdone = FALSE;
#ifdef KANJI
		if ((c & 0xff00) && c != (KS1 << 8 | KS2)
			|| isascii(c) && isalnum(c) || c == '_')
#else
		if (isascii(c) && isalnum(c) || c == '_')
#endif
		{
			/*
			 * no match; abbrev is part of a longer word
			 */
			mapback(mkstr(c));
			*mbuf = NUL;
			return -1;
		}
		/*
		 * place backspaces to clear the word just entered
		 */
		p = mbuf;
		for (q = (uchar *)msave->m_key; *q; q++) {
#ifdef KANJI
			if (isKanji(*q))
				q++;
#endif
			*p++ = BS;
		}
		*p++ = NUL;
		strcat(mbuf, msave->m_str);
		strcat(mbuf, mkstr(c));
		mapback(mbuf);
		*mbuf = NUL;
		return -1;
	}
	if (*mbuf == NUL) {
		abbrev = FALSE;
	}
	strcat(mbuf, mkstr(c));
	mlen = strlen(mbuf);
	partof = FALSE;
	for (m = Maptab, i = 0; i < nmap; i++, m++) {
		if (State == NORMAL && m->m_type != MAPC ||
		    State != NORMAL && m->m_type == MAPC ||
		    abbrev == FALSE && m->m_type == ABBR && can_ab == FALSE)
			continue;
		if (strncmp(mbuf, m->m_key, mlen) == 0) {
			if (mlen >= m->m_len) {
				/*
				 * completely matched;
				 * push back mapped string and
				 * clear mapping buffer
				 */
				if (m->m_type == ABBR) {
					/*
					 * do it later, since abbreviation
					 * matches only if the next character
					 * is a punctuation or a white space
					 */
					abdone = TRUE;
					msave = m;
					return c;
				}
				mapback(m->m_str);
				*mbuf = NUL;
				return -1;
			}
			mpos = m;
			partof = TRUE;
		}
	}
	if (partof) {
		/*
		 * partially matched
		 */
		if (mpos->m_type == ABBR) {
			abbrev = TRUE;
			return c;
		} else
			return -1;
	}
	/*
	 * not matched
	 */
	if (!abbrev) {
#ifdef KANJI
		if (isKanji(*mbuf)) {
			if (mbuf[2] != NUL)
				mapback(mbuf + 2);
			c = (*mbuf << 8) | mbuf[1];
		} else {
			if (mbuf[1] != NUL)
				mapback(mbuf + 1);
			c = *mbuf;
		}
#else
		if (mbuf[1] != NUL)
			mapback(mbuf + 1);
		c = *mbuf;
#endif
	}
	*mbuf = NUL;
	return c;
}

int
vgetc()
{
	register int	c;

	/*
	 * inchar() may map special keys by using stuffin(). If it does
	 * so, it returns -1 so we know to loop here to get a real char.
	 */
	do {
		if ( mapcnext != NULL ) {
			c = *mapcnext++;
#ifdef KANJI
			if (isKanji(c))
				c = (c << 8) | *mapcnext++;
#endif
			if ( *mapcnext == NUL ) {
				*mapcbuff = NUL;
				mapcnext = NULL;
			}
			c = map(c);
		} else if ( getcnext != NULL ) {
			c = *getcnext++;
#ifdef KANJI
			if (isKanji(c))
				c = (c << 8) | *getcnext++;
#endif
			if ( *getcnext == NUL ) {
				*getcbuff = NUL;
				getcnext = NULL;
			}
		} else {
			c = map(inchar());
		}
	} while (c == -1);

	return c;
}

/*
 * anyinput
 *
 * Return non-zero if input is pending.
 */

bool_t
anyinput()
{
	return (getcnext != NULL);
}

/*
 * do_mlines() - process mode lines for the current file
 *
 * Returns immediately if the "ml" parameter isn't set.
 */
#define	NMLINES	5	/* no. of lines at start/end to check for modelines */

void
do_mlines()
{
	void	chk_mline();
	int	i;
	register LPTR	*p;

	if (!P(P_ML))
		return;

	p = Filemem;
	for (i=0; i < NMLINES ;i++) {
		chk_mline(p->linep->s);
		if ((p = nextline(p)) == NULL)
			break;
	}

	if ((p = prevline(Fileend)) == NULL)
		return;

	for (i=0; i < NMLINES ;i++) {
		chk_mline(p->linep->s);
		if ((p = prevline(p)) == NULL)
			break;
	}
}

/*
 * chk_mline() - check a single line for a mode string
 */
static void
chk_mline(s)
register uchar	*s;
{
	register uchar	*cs;		/* local copy of any modeline found */
	register uchar	*e;

	for (; *s != NUL ;s++) {
		if (strncmp(s, "vi:", 3) == 0 || strncmp(s, "ex:", 3) == 0) {
			cs = strsave(s+3);
			if ((e = (uchar *)strchr(cs, ':')) != NULL) {
				*e = NUL;
				stuffin(mkstr(Ctrl('O')));
				docmdln(cs);
			}
			free(cs);
		}
	}
}
