/* $Header: /nw/tony/src/stevie/src/RCS/param.h,v 1.8 89/08/02 10:59:35 tony Exp $
 *
 * Settable parameters
 */

struct	param {
	char	*fullname;	/* full parameter name */
	char	*shortname;	/* permissible abbreviation */
	int	value;		/* parameter value */
	int	flags;
};

extern	struct	param	params[];

/*
 * Flags
 */
#define	P_BOOL		0x01	/* the parameter is boolean */
#define	P_NUM		0x02	/* the parameter is numeric */
#define	P_CHANGED	0x04	/* the parameter has been changed */

/*
 * The following are the indices in the params array for each parameter
 */

/*
 * Numeric/Boolean parameters
 */
#ifdef FEPCTRL
#define	P_AI	0	/* (B) auto-indent */
#define	P_AW	1	/* (B) auto write */
#define	P_BK	2	/* (B) make backups when writing out files */
#define	P_EB	3	/* (B) error bells */
#define	P_FC	4	/* (B) control Japanese front-end processor */
#define	P_IC	5	/* (B) ignore case in searches */
#define	P_LI	6	/* (N) lines */
#define	P_LS	7	/* (B) show tabs and newlines graphically */
#define	P_ML	8	/* (B) enables mode-lines processing */
#define	P_NU	9	/* (B) number lines on the screen */
#define	P_RO	10	/* (B) read only */
#define	P_RD	11	/* (B) ignored; here for compatibility */
#define	P_RP	12	/* (N) report */
#define	P_CR	13	/* (B) use cr-lf to terminate lines on writes */
#define	P_SS	14	/* (N) scroll size */
#define	P_SW	15	/* (N) shiftwidth */
#define	P_SM	16	/* (B) showmatch */
#define	P_MO	17	/* (B) show mode */
#define	P_TS	18	/* (N) tab size */
#define	P_TE	19	/* (B) ignored; here for compatibility */
#define	P_TO	20	/* (B) if true, tilde is an operator */
#define	P_VB	21	/* (B) visual bell */
#define	P_WS	22	/* (B) wrap scan */
#else
#define	P_AI	0	/* (B) auto-indent */
#define	P_AW	1	/* (B) auto write */
#define	P_BK	2	/* (B) make backups when writing out files */
#define	P_EB	3	/* (B) error bells */
#define	P_IC	4	/* (B) ignore case in searches */
#define	P_LI	5	/* (N) lines */
#define	P_LS	6	/* (B) show tabs and newlines graphically */
#define	P_ML	7	/* (B) enables mode-lines processing */
#define	P_NU	8	/* (B) number lines on the screen */
#define	P_RO	9	/* (B) read only */
#define	P_RD	10	/* (B) ignored; here for compatibility */
#define	P_RP	11	/* (N) report */
#define	P_CR	12	/* (B) use cr-lf to terminate lines on writes */
#define	P_SS	13	/* (N) scroll size */
#define	P_SW	14	/* (N) shiftwidth */
#define	P_SM	15	/* (B) showmatch */
#define	P_MO	16	/* (B) show mode */
#define	P_TS	17	/* (N) tab size */
#define	P_TE	18	/* (B) ignored; here for compatibility */
#define	P_TO	19	/* (B) if true, tilde is an operator */
#define	P_VB	20	/* (B) visual bell */
#define	P_WS	21	/* (B) wrap scan */
#endif

/*
 * Macro to get the value of a parameter
 */
#define	P(n)	(params[n].value)
